-- author: DD ModPassion
-- date: 22.11.2021
-- copyright (C): DD ModPassion, All Rights Reserved
-- version: Farming Simulator 22
AddFillTypes = {} local modDirectory = g_currentModDirectory or "unknown" local modName = g_currentModName function AddFillTypes.loadMapData(modDesc, missionInfo, baseDirectory, isBaseType) local xmlFile = loadXMLFile("ModFile", modDirectory.."modDesc.xml") local i = 0 while true do local baseKey = string.format("modDesc.fillTypes.fillType(%d)", i) if not hasXMLProperty(xmlFile, baseKey) then break end local name = getXMLString(xmlFile, baseKey.."#name") local title = g_i18n:getText(string.gsub(getXMLString(xmlFile, baseKey.."#title"),"$l10n_", "")) if title ~= nil and title:sub(1, 6) == "$l10n_" then title = g_i18n:getText(title:sub(7)) end local showOnPriceTable = getXMLBool(xmlFile, baseKey.."#showOnPriceTable") local fillPlaneColors = getXMLString(xmlFile, baseKey.."#fillPlaneColors", "1.0 1.0 1.0", true) local unitShort = getXMLString(xmlFile, baseKey.."#unitShort", "") local kgPerLiter = getXMLFloat(xmlFile, baseKey..".physics#massPerLiter") local massPerLiter = kgPerLiter and kgPerLiter / 1000 local maxPhysicalSurfaceAngle = getXMLFloat(xmlFile, baseKey..".physics#maxPhysicalSurfaceAngle") local pricePerLiter = getXMLFloat(xmlFile, baseKey..".economy#pricePerLiter") local hudFilename = getXMLString(xmlFile, baseKey..".image#hud") local palletFilename = getXMLString(xmlFile, baseKey..".pallet#filename") if g_fillTypeManager:getFillTypeByName(name) == nil then g_fillTypeManager:addFillType(name, title, showOnPriceTable, pricePerLiter, massPerLiter, maxPhysicalSurfaceAngle, hudFilename, modDirectory, nil, fillPlaneColors, unitShort, palletFilename, {}, nil, nil, nil, nil, nil, nil, nil, nil, isBaseType or false) if unitShort ~= "" and unitShort:sub(1, 6) == "$l10n_" then g_fillTypeManager.nameToFillType[name].unitShort = g_i18n:getText(unitShort:sub(7)) end Logging.info("Mod: '%s' Added fill type = '%s'", modName, name) end i = i + 1 end local key = string.format("modDesc.fillTypeCategories.fillTypeCategory") local name = getXMLString(xmlFile, key .. "#name") local fillTypesStr = getXMLString(xmlFile, key) or "" if name ~= nil then local productName = "PRODUCT" local productFillTypeCategoryIndex = g_fillTypeManager.nameToCategoryIndex[productName] local fillTypeCategoryIndex = g_fillTypeManager:addFillTypeCategory(name, isBaseType) if fillTypeCategoryIndex ~= nil then local fillTypeNames = fillTypesStr:split(" ") for _, fillTypeName in ipairs(fillTypeNames) do local fillType = g_fillTypeManager:getFillTypeByName(fillTypeName) if fillType ~= nil then g_fillTypeManager:addFillTypeToCategory(fillType.index, fillTypeCategoryIndex) if productFillTypeCategoryIndex ~= nil then g_fillTypeManager:addFillTypeToCategory(fillType.index, productFillTypeCategoryIndex) end end end Logging.info("Mod: '%s' Added fill type category = '%s'", modName, name) end end delete(xmlFile) end function AddFillTypes.loadMap(mission, node) g_currentMission.hud.fillLevelsDisplay:refreshFillTypes(g_fillTypeManager) end function AddFillTypes.init() local modDesc = loadXMLFile("ModFile", modDirectory.."modDesc.xml") local key = string.format("modDesc.storePacks.storePack") local name = getXMLString(modDesc, key.."#name") local title = getXMLString(modDesc, key.."#title") local imageFilename = getXMLString(modDesc, key.."#image") if title ~= nil and title:sub(1, 6) == "$l10n_" then title = g_i18n:getText(title:sub(7)) end delete(modDesc) g_storeManager:addPack(name, title, imageFilename, modDirectory) Logging.info("Mod: '%s' Added store packs = '%s'", modName, name) FillTypeManager.loadMapData = Utils.appendedFunction(FillTypeManager.loadMapData, AddFillTypes.loadMapData) FSBaseMission.loadMap = Utils.prependedFunction(FSBaseMission.loadMap, AddFillTypes.loadMap) end AddFillTypes.init()